给定一个整数数组 nums 和一个目标值 target,在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
主要思想:
1、利用HashMap,key为数组元素,value为元素下标;
2、求目标数字和当前遍历元素的差值s;
3、判断HashMap中是否包含指定的键s;
4、存在,则返回s下标和当前a[i]下标;
5、不存在,则把当前元素及其下标存储在HashMap中;
6、算法时间复杂度O(n)。
class Solution {
public int[] twoSum(int[] nums, int target) {
HashMap<Integer,Integer> map = new HashMap<Integer,Integer>();
for(int i = 0;i<nums.length;i++){
int s = target - nums[i];
if(map.containsKey(s)){
return new int[]{map.get(s),i};
}
map.put(nums[i],i);
}
return new int[2];
}
}